<html>
<head>
<title>OGRE: OgreStdHeaders.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreStdHeaders.h</h1><a href="OgreStdHeaders_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="preprocessor">#ifndef __StdHeaders_H__</span>
<a name="l00002"></a>00002 <span class="preprocessor"></span><span class="preprocessor">#define __StdHeaders_H__</span>
<a name="l00003"></a>00003 <span class="preprocessor"></span>
<a name="l00004"></a>00004 <span class="preprocessor">#ifdef __BORLANDC__</span>
<a name="l00005"></a>00005 <span class="preprocessor"></span><span class="preprocessor">    #define __STD_ALGORITHM</span>
<a name="l00006"></a>00006 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00007"></a>00007 <span class="preprocessor"></span>
<a name="l00008"></a>00008 <span class="preprocessor">#if defined ( OGRE_GCC_VISIBILITY )</span>
<a name="l00009"></a>00009 <span class="preprocessor"></span><span class="comment">/* Until libstdc++ for gcc 4.2 is released, we have to declare all</span>
<a name="l00010"></a>00010 <span class="comment"> * symbols in libstdc++.so externally visible, otherwise we end up</span>
<a name="l00011"></a>00011 <span class="comment"> * with them marked as hidden by -fvisible=hidden.</span>
<a name="l00012"></a>00012 <span class="comment"> *</span>
<a name="l00013"></a>00013 <span class="comment"> * See http://gcc.gnu.org/bugzilla/show_bug.cgi?id=20218</span>
<a name="l00014"></a>00014 <span class="comment"> */</span>
<a name="l00015"></a>00015 <span class="preprocessor">#   pragma GCC visibility push(default)</span>
<a name="l00016"></a>00016 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00017"></a>00017 <span class="preprocessor"></span>
<a name="l00018"></a>00018 <span class="preprocessor">#include &lt;cassert&gt;</span>
<a name="l00019"></a>00019 <span class="preprocessor">#include &lt;cstdio&gt;</span>
<a name="l00020"></a>00020 <span class="preprocessor">#include &lt;cstdlib&gt;</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &lt;ctime&gt;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;cstring&gt;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;cstdarg&gt;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;cmath&gt;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// STL containers</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &lt;list&gt;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &lt;deque&gt;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &lt;queue&gt;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &lt;bitset&gt;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">// Note - not in the original STL, but exists in SGI STL and STLport</span>
<a name="l00037"></a>00037 <span class="preprocessor">#if (OGRE_COMPILER == OGRE_COMPILER_GNUC) &amp;&amp; !defined(STLPORT)</span>
<a name="l00038"></a>00038 <span class="preprocessor"></span><span class="preprocessor">#   include &lt;ext/hash_map&gt;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#   include &lt;ext/hash_set&gt;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#else</span>
<a name="l00041"></a>00041 <span class="preprocessor"></span><span class="preprocessor">#   include &lt;hash_set&gt;</span>
<a name="l00042"></a>00042 <span class="preprocessor">#   include &lt;hash_map&gt;</span>
<a name="l00043"></a>00043 <span class="preprocessor">#endif</span>
<a name="l00044"></a>00044 <span class="preprocessor"></span>
<a name="l00045"></a>00045 <span class="comment">// STL algorithms &amp; functions</span>
<a name="l00046"></a>00046 <span class="preprocessor">#include &lt;algorithm&gt;</span>
<a name="l00047"></a>00047 <span class="preprocessor">#include &lt;functional&gt;</span>
<a name="l00048"></a>00048 <span class="preprocessor">#include &lt;limits&gt;</span>
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 <span class="comment">// C++ Stream stuff</span>
<a name="l00051"></a>00051 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00052"></a>00052 <span class="preprocessor">#include &lt;iostream&gt;</span>
<a name="l00053"></a>00053 <span class="preprocessor">#include &lt;iomanip&gt;</span>
<a name="l00054"></a>00054 <span class="preprocessor">#include &lt;sstream&gt;</span>
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 <span class="preprocessor">#ifdef __BORLANDC__</span>
<a name="l00057"></a>00057 <span class="preprocessor"></span><span class="keyword">namespace </span>Ogre
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059     <span class="keyword">using namespace </span>std;
<a name="l00060"></a>00060 }
<a name="l00061"></a>00061 <span class="preprocessor">#endif</span>
<a name="l00062"></a>00062 <span class="preprocessor"></span>
<a name="l00063"></a>00063 <span class="keyword">extern</span> <span class="stringliteral">"C"</span> {
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 <span class="preprocessor">#   include &lt;sys/types.h&gt;</span>
<a name="l00066"></a>00066 <span class="preprocessor">#   include &lt;sys/stat.h&gt;</span>
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 }
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 <span class="preprocessor">#if OGRE_PLATFORM == OGRE_PLATFORM_WIN32</span>
<a name="l00071"></a>00071 <span class="preprocessor"></span><span class="preprocessor">#  undef min</span>
<a name="l00072"></a>00072 <span class="preprocessor"></span><span class="preprocessor">#  undef max</span>
<a name="l00073"></a>00073 <span class="preprocessor"></span><span class="preprocessor">#  if defined( __MINGW32__ )</span>
<a name="l00074"></a>00074 <span class="preprocessor"></span><span class="preprocessor">#    include &lt;unistd.h&gt;</span>
<a name="l00075"></a>00075 <span class="preprocessor">#  endif</span>
<a name="l00076"></a>00076 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00077"></a>00077 <span class="preprocessor"></span>
<a name="l00078"></a>00078 <span class="preprocessor">#if OGRE_PLATFORM == OGRE_PLATFORM_LINUX</span>
<a name="l00079"></a>00079 <span class="preprocessor"></span><span class="keyword">extern</span> <span class="stringliteral">"C"</span> {
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 <span class="preprocessor">#   include &lt;unistd.h&gt;</span>
<a name="l00082"></a>00082 <span class="preprocessor">#   include &lt;dlfcn.h&gt;</span>
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 }
<a name="l00085"></a>00085 <span class="preprocessor">#endif</span>
<a name="l00086"></a>00086 <span class="preprocessor"></span>
<a name="l00087"></a>00087 <span class="preprocessor">#if OGRE_PLATFORM == OGRE_PLATFORM_APPLE</span>
<a name="l00088"></a>00088 <span class="preprocessor"></span><span class="keyword">extern</span> <span class="stringliteral">"C"</span> {
<a name="l00089"></a>00089 <span class="preprocessor">#   include &lt;unistd.h&gt;</span>
<a name="l00090"></a>00090 <span class="preprocessor">#   include &lt;sys/param.h&gt;</span>
<a name="l00091"></a>00091 <span class="preprocessor">#   include &lt;CoreFoundation/CoreFoundation.h&gt;</span>
<a name="l00092"></a>00092 }
<a name="l00093"></a>00093 <span class="preprocessor">#endif</span>
<a name="l00094"></a>00094 <span class="preprocessor"></span>
<a name="l00095"></a>00095 <span class="preprocessor">#if OGRE_THREAD_SUPPORT</span>
<a name="l00096"></a>00096 <span class="preprocessor"></span><span class="preprocessor">#   include &lt;boost/thread/recursive_mutex.hpp&gt;</span>
<a name="l00097"></a>00097 <span class="preprocessor">#endif</span>
<a name="l00098"></a>00098 <span class="preprocessor"></span>
<a name="l00099"></a>00099 <span class="preprocessor">#if defined ( OGRE_GCC_VISIBILITY )</span>
<a name="l00100"></a>00100 <span class="preprocessor"></span><span class="preprocessor">#   pragma GCC visibility pop</span>
<a name="l00101"></a>00101 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00102"></a>00102 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:56 2008
</p>
</body>
</html>
